*********** Simulation des cotisations sociales et du revenu primaire du travail
*********** choix de l'anne de simulation dans do_appel_parametres
*********** Choix du rpertoire racine dans do_appel_parametres ( excuter en premier)

clear

set mem 500m 
set more off


/******** appel des paramtres*/
do Programmes/do_appel_parametres


/*********************phase 1: calcul des cotisations sociales sur revenus d'activit */
use Fichiers/indiv_demo_$annee, clear
keep id_indiv pondv ya_irpp sal_irpp nonsal_irpp nbh nbh_sal nbh_nonsal public yr_irpp pension_irpp chom_irpp
gen calage=0
replace public=0 if public==. & calage==1-$calagecn
replace nbh=1 if sal_irpp==0 & calage==1-$calagecn
replace nbh_sal=1 if sal_irpp==0 & calage==1-$calagecn

/*********phase 1-1: calcul du salaire brut et des cotisations sociales salariales*/
gen smic_h_irpp=(1-$tx_csg_ded-$tx_css_priv_0)*$smic_h_brut
gen smic_irpp=smic_h_irpp*$nbh_pt

/********phase 1-1-1: secteur public*/
gen sal_brut=0
replace sal_brut=sal_irpp/(1-$tx_csg_ded-$tx_css_pub_0) if public==1
gen css_sim=0
replace css_sim=(1-$tx_csg_ded)*sal_brut-sal_irpp if public==1
gen css_contr=0
replace css_contr=$tx_css_pub_contr_0*sal_brut if public==1
gen css_noncontr=0
replace css_noncontr=$tx_css_pub_noncontr_0*sal_brut if public==1

/********phase 1-1-2: secteur priv*/
/**calcul du salaire brut*/
replace sal_brut=sal_irpp/(1-$tx_csg_ded-$tx_css_priv_0) if public==0
gen sal_h_brut=sal_brut/nbh_sal
replace sal_brut=(sal_irpp+($tx_css_priv_0-$tx_css_priv_pss)*$pss_h_brut*nbh_sal)/(1-$tx_csg_ded-$tx_css_priv_pss) if sal_h_brut>=$pss_h_brut & public==0
replace sal_h_brut=sal_brut/nbh_sal if sal_h_brut>=$pss_h_brut & public==0
replace sal_brut=(sal_irpp+($tx_css_priv_0+3*$tx_css_priv_pss-4*$tx_css_priv_4pss)*$pss_h_brut*nbh_sal)/(1-$tx_csg_ded-$tx_css_priv_4pss) if sal_h_brut>=4*$pss_h_brut & public==0
replace sal_h_brut=sal_brut/nbh_sal if sal_h_brut>=4*$pss_h_brut & public==0
replace sal_brut=(sal_irpp+($tx_css_priv_0+3*$tx_css_priv_pss+4*$tx_css_priv_4pss-8*$tx_css_priv_8pss)*$pss_h_brut*nbh_sal)/(1-$tx_csg_ded-$tx_css_priv_8pss) if sal_h_brut>=8*$pss_h_brut & public==0
replace sal_h_brut=sal_brut/nbh_sal if sal_h_brut>=8*$pss_h_brut & public==0
/**calcul des cotisations*/
replace css_sim=(1-$tx_csg_ded)*sal_brut-sal_irpp if public==0
replace css_contr=$tx_css_priv_contr_0*sal_brut if sal_h_brut<=$pss_h_brut & public==0 
replace css_contr=$tx_css_priv_contr_0*$pss_h_brut*nbh_sal+$tx_css_priv_contr_pss*(sal_brut-$pss_h_brut*nbh_sal) if sal_h_brut>$pss_h_brut & sal_h_brut<=4*$pss_h_brut & public==0
replace css_contr=$tx_css_priv_contr_0*$pss_h_brut*nbh_sal+$tx_css_priv_contr_pss*3*$pss_h_brut*nbh_sal+$tx_css_priv_contr_4pss*(sal_brut-4*$pss_h_brut*nbh_sal) if sal_h_brut>4*$pss_h_brut & sal_h_brut<=8*$pss_h_brut & public==0
replace css_contr=$tx_css_priv_contr_0*$pss_h_brut*nbh_sal+$tx_css_priv_contr_pss*3*$pss_h_brut*nbh_sal+$tx_css_priv_contr_4pss*4*$pss_h_brut*nbh_sal+$tx_css_priv_contr_8pss*(sal_brut-8*$pss_h_brut*nbh_sal) if sal_h_brut>8*$pss_h_brut & public==0
replace css_noncontr=$tx_css_priv_noncontr_0*sal_brut if sal_h_brut<=$pss_h_brut & public==0 
replace css_noncontr=$tx_css_priv_noncontr_0*$pss_h_brut*nbh_sal+$tx_css_priv_noncontr_pss*(sal_brut-$pss_h_brut*nbh_sal) if sal_h_brut>$pss_h_brut & sal_h_brut<=4*$pss_h_brut & public==0
replace css_noncontr=$tx_css_priv_noncontr_0*$pss_h_brut*nbh_sal+$tx_css_priv_noncontr_pss*3*$pss_h_brut*nbh_sal+$tx_css_priv_noncontr_4pss*(sal_brut-4*$pss_h_brut*nbh_sal) if sal_h_brut>4*$pss_h_brut & sal_h_brut<=8*$pss_h_brut & public==0
replace css_noncontr=$tx_css_priv_noncontr_0*$pss_h_brut*nbh_sal+$tx_css_priv_noncontr_pss*3*$pss_h_brut*nbh_sal+$tx_css_priv_noncontr_4pss*4*$pss_h_brut*nbh_sal+$tx_css_priv_noncontr_8pss*(sal_brut-8*$pss_h_brut*nbh_sal) if sal_h_brut>8*$pss_h_brut & public==0
 
/*********phase 1-1-3: calage des cotisations salariales sur comptabilit nationale*/
egen masse_css_sim=total(css_sim*pondv/1000000000)
gen assiette_css_irpp=$masse_css_cn/masse_css_sim
gen css=css_sim
replace css=css_sim*assiette_css_irpp if calage==$calagecn
replace css_contr=css_contr*assiette_css_irpp if calage==$calagecn
replace css_noncontr=css_noncontr*assiette_css_irpp if calage==$calagecn
egen masse_sal_brut_priv=total(sal_brut*(1-public)*pondv/1000000000)
gen assiette_sal_irpp_csg_priv=masse_sal_brut_priv/$masse_sal_priv_csg
egen masse_sal_brut_pub=total(sal_brut*public*pondv/1000000000)
gen assiette_sal_irpp_csg_pub=masse_sal_brut_pub/$masse_sal_pub_csg
gen sal_brut_csg=sal_brut
replace sal_brut_csg=sal_brut/assiette_sal_irpp_csg_priv if calage==$calagecn
replace sal_brut_csg=sal_brut/assiette_sal_irpp_csg_pub if public==1 & calage==$calagecn
gen assiette_sal_csg_cn_priv=$masse_sal_priv_csg/$masse_sal_priv_cn
gen assiette_sal_csg_cn_pub=$masse_sal_pub_csg/$masse_sal_pub_cn
gen sal_brut_cn=sal_brut_csg 
replace sal_brut_cn=sal_brut_csg/assiette_sal_csg_cn_priv if calage==$calagecn
replace sal_brut_cn=sal_brut_csg/assiette_sal_csg_cn_pub if public==1 & calage==$calagecn

/**********phase 1-2: calcul des cotisations sociales patronales pour les salaris du secteur priv*/
/****** phase 1-2-1: calcul des cotisations patronales*/
gen csp_sim=0
replace csp_sim=$tx_csp_priv_0*sal_brut if sal_h_brut<$pss_h_brut & public==0
replace csp_sim=$tx_csp_priv_0*nbh_sal*$pss_h_brut+$tx_csp_priv_pss*(sal_brut-nbh_sal*$pss_h_brut) if sal_h_brut>=$pss_h_brut & sal_h_brut<2*$pss_h_brut & public==0
replace csp_sim=$tx_csp_priv_0*nbh_sal*$pss_h_brut+$tx_csp_priv_pss*nbh_sal*$pss_h_brut+$tx_csp_priv_2pss*(sal_brut-2*nbh_sal*$pss_h_brut)  if sal_h_brut>=2*$pss_h_brut & sal_h_brut<4*$pss_h_brut & public==0
replace csp_sim=$tx_csp_priv_0*nbh_sal*$pss_h_brut+$tx_csp_priv_pss*nbh_sal*$pss_h_brut+$tx_csp_priv_2pss*2*nbh_sal*$pss_h_brut+$tx_csp_priv_4pss*(sal_brut-4*nbh_sal*$pss_h_brut) if sal_h_brut>=4*$pss_h_brut & sal_h_brut<8*$pss_h_brut & public==0
replace csp_sim=$tx_csp_priv_0*nbh_sal*$pss_h_brut+$tx_csp_priv_pss*nbh_sal*$pss_h_brut+$tx_csp_priv_2pss*2*nbh_sal*$pss_h_brut+$tx_csp_priv_4pss*4*nbh_sal*$pss_h_brut +$tx_csp_priv_8pss*(sal_brut-8*nbh_sal*$pss_h_brut) if sal_h_brut>=8*$pss_h_brut & public==0

/*****phase 1-2-2: calcul de l'abattement cotisation patronale bas salaires (exo Fillon)*/
gen tx_exo_fillon=$tx_max_exo_fillon*(max(($seuil_exo_fillon*$smic_h_brut/sal_h_brut)-1,0))/($seuil_exo_fillon-1) if public==0
gen csp_exo_fillon=0
replace csp_exo_fillon=tx_exo_fillon*sal_brut if public==0

/*****phase 1-2-3: calcul des cotisations contributives et non contributives*/
gen csp_contr=0
replace csp_contr=$tx_csp_priv_contr_0*sal_brut if sal_h_brut<$pss_h_brut & public==0
replace csp_contr=$tx_csp_priv_contr_0*nbh_sal*$pss_h_brut+$tx_csp_priv_contr_pss*(sal_brut-nbh_sal*$pss_h_brut) if sal_h_brut>=$pss_h_brut & sal_h_brut<2*$pss_h_brut & public==0
replace csp_contr=$tx_csp_priv_contr_0*nbh_sal*$pss_h_brut+$tx_csp_priv_contr_pss*nbh_sal*$pss_h_brut+$tx_csp_priv_contr_2pss*(sal_brut-2*nbh_sal*$pss_h_brut)  if sal_h_brut>=2*$pss_h_brut & sal_h_brut<4*$pss_h_brut & public==0
replace csp_contr=$tx_csp_priv_contr_0*nbh_sal*$pss_h_brut+$tx_csp_priv_contr_pss*nbh_sal*$pss_h_brut+$tx_csp_priv_contr_2pss*2*nbh_sal*$pss_h_brut+$tx_csp_priv_contr_4pss*(sal_brut-4*nbh_sal*$pss_h_brut) if sal_h_brut>=4*$pss_h_brut & sal_h_brut<8*$pss_h_brut & public==0
replace csp_contr=$tx_csp_priv_contr_0*nbh_sal*$pss_h_brut+$tx_csp_priv_contr_pss*nbh_sal*$pss_h_brut+$tx_csp_priv_contr_2pss*2*nbh_sal*$pss_h_brut+$tx_csp_priv_contr_4pss*4*nbh_sal*$pss_h_brut +$tx_csp_priv_contr_8pss*(sal_brut-8*nbh_sal*$pss_h_brut) if sal_h_brut>=8*$pss_h_brut & public==0
gen csp_noncontr=0
replace csp_noncontr=$tx_csp_priv_noncontr_0*sal_brut if sal_h_brut<$pss_h_brut & public==0
replace csp_noncontr=$tx_csp_priv_noncontr_0*nbh_sal*$pss_h_brut+$tx_csp_priv_noncontr_pss*(sal_brut-nbh_sal*$pss_h_brut) if sal_h_brut>=$pss_h_brut & sal_h_brut<2*$pss_h_brut & public==0
replace csp_noncontr=$tx_csp_priv_noncontr_0*nbh_sal*$pss_h_brut+$tx_csp_priv_noncontr_pss*nbh_sal*$pss_h_brut+$tx_csp_priv_noncontr_2pss*(sal_brut-2*nbh_sal*$pss_h_brut)  if sal_h_brut>=2*$pss_h_brut & sal_h_brut<4*$pss_h_brut & public==0
replace csp_noncontr=$tx_csp_priv_noncontr_0*nbh_sal*$pss_h_brut+$tx_csp_priv_noncontr_pss*nbh_sal*$pss_h_brut+$tx_csp_priv_noncontr_2pss*2*nbh_sal*$pss_h_brut+$tx_csp_priv_noncontr_4pss*(sal_brut-4*nbh_sal*$pss_h_brut) if sal_h_brut>=4*$pss_h_brut & sal_h_brut<8*$pss_h_brut & public==0
replace csp_noncontr=$tx_csp_priv_noncontr_0*nbh_sal*$pss_h_brut+$tx_csp_priv_noncontr_pss*nbh_sal*$pss_h_brut+$tx_csp_priv_noncontr_2pss*2*nbh_sal*$pss_h_brut+$tx_csp_priv_noncontr_4pss*4*nbh_sal*$pss_h_brut +$tx_csp_priv_noncontr_8pss*(sal_brut-8*nbh_sal*$pss_h_brut) if sal_h_brut>=8*$pss_h_brut & public==0

/*********phase 1-2-4: calage des cotisations patronales sur comptabilit nationale*/
/*****contisations patronales du secteur priv*/
egen masse_csp_priv_sim=total(csp_sim*pondv/1000000000)
gen assiette_csp_irpp=($masse_csp_priv_cn+$masse_csp_priv_exo_fillon)/masse_csp_priv_sim
replace csp_contr=csp_contr*assiette_csp_irpp if calage==$calagecn
replace csp_noncontr=csp_noncontr*assiette_csp_irpp if calage==$calagecn
egen masse_csp_priv_exo_fillon_sim=total(csp_exo_fillon*pondv/1000000000)
gen assiette_csp_exo_fillon=$masse_csp_priv_exo_fillon/masse_csp_priv_exo_fillon_sim
replace csp_exo_fillon=csp_exo_fillon*assiette_csp_exo_fillon if calage==$calagecn
gen csp=csp_contr+csp_noncontr-csp_exo_fillon
/**** cotisations patronales du secteur public*/
gen tx_csp_pub_0=$masse_csp_pub_cn/masse_sal_brut_pub
replace csp=tx_csp_pub_0*sal_brut if public==1 
replace csp_noncontr=$tx_csp_pub_noncontr_0*sal_brut if public==1  
replace csp_contr=csp-csp_noncontr if public==1
replace csp_contr=0 if public==1 & calage==1-$calagecn
replace csp=csp_contr+csp_noncontr if public==1 & calage==1-$calagecn
/**** cotisations patronales facultatives du secteur priv*/
gen tx_csp_priv_fac=$masse_csp_priv_fac_cn/masse_sal_brut_priv
gen csp_fac=0
replace csp_fac=tx_csp_priv_fac*sal_brut if public==0 & calage==$calagecn
/**** impts sur les salaires et la main d'oeuvre du secteur priv*/
gen tx_ts_priv=$masse_ts_cn/masse_sal_brut_priv
gen ts=0
replace ts=tx_ts_priv*sal_brut if public==0 & calage==$calagecn
/**** salaires super-bruts dans les secteurs public et priv*/
gen sal_superbrut_cn=sal_brut_cn+csp+csp_fac+ts
gen csg_sal=($tx_csg_ded+$tx_csg_nonded)*sal_brut_csg

/***********phase 1-3: calcul du revenu brut et des cotisations sociales pour les non salaris*/
/****phase 1-3-1: revenu brut et cotisations des non salaris*/
gen nonsal_brut=nonsal_irpp/(1-$tx_csg_ded_nonsal-$tx_cs_nonsal_0)
gen nonsal_h_brut=nonsal_brut/nbh_nonsal
replace nonsal_brut=(nonsal_irpp+($tx_cs_nonsal_0-$tx_cs_nonsal_pss)*$pss_h_brut*nbh_nonsal)/(1-$tx_csg_ded_nonsal-$tx_cs_nonsal_pss) if nonsal_h_brut>=$pss_h_brut & nonsal_brut>0
replace nonsal_h_brut=nonsal_brut/nbh_nonsal if nonsal_h_brut>=$pss_h_brut
replace nonsal_brut=(nonsal_irpp+($tx_cs_nonsal_0+3*$tx_cs_nonsal_pss-4*$tx_cs_nonsal_4pss)*$pss_h_brut*nbh_nonsal)/(1-$tx_csg_ded_nonsal-$tx_cs_nonsal_4pss) if nonsal_h_brut>=4*$pss_h_brut & nonsal_brut>0
replace nonsal_h_brut=nonsal_brut/nbh_nonsal if nonsal_h_brut>=4*$pss_h_brut
gen cs_nonsal_sim=(1-$tx_csg_ded_nonsal)*nonsal_brut-nonsal_irpp
gen cs_nonsal_contr=0
replace cs_nonsal_contr=$tx_cs_nonsal_contr_0*nonsal_brut if nonsal_h_brut<=$pss_h_brut & nonsal_brut>0
replace cs_nonsal_contr=$tx_cs_nonsal_contr_0*$pss_h_brut*nbh_nonsal+$tx_cs_nonsal_contr_pss*(nonsal_brut-$pss_h_brut*nbh_nonsal) if nonsal_h_brut>$pss_h_brut & nonsal_h_brut<=4*$pss_h_brut & nonsal_brut>0
replace cs_nonsal_contr=$tx_cs_nonsal_contr_0*$pss_h_brut*nbh_nonsal+$tx_cs_nonsal_contr_pss*3*$pss_h_brut*nbh_nonsal+$tx_cs_nonsal_contr_4pss*(nonsal_brut-4*$pss_h_brut*nbh_nonsal) if nonsal_h_brut>4*$pss_h_brut & nonsal_brut>0 
gen cs_nonsal_noncontr=0
replace cs_nonsal_noncontr=$tx_cs_nonsal_noncontr_0*nonsal_brut if nonsal_h_brut<=$pss_h_brut & nonsal_brut>0
replace cs_nonsal_noncontr=$tx_cs_nonsal_noncontr_0*$pss_h_brut*nbh_nonsal+$tx_cs_nonsal_noncontr_pss*(nonsal_brut-$pss_h_brut*nbh_nonsal) if nonsal_h_brut>$pss_h_brut & nonsal_h_brut<=4*$pss_h_brut & nonsal_brut>0
replace cs_nonsal_noncontr=$tx_cs_nonsal_noncontr_0*$pss_h_brut*nbh_nonsal+$tx_cs_nonsal_noncontr_pss*3*$pss_h_brut*nbh_nonsal+$tx_cs_nonsal_noncontr_4pss*(nonsal_brut-4*$pss_h_brut*nbh_nonsal) if nonsal_h_brut>4*$pss_h_brut & nonsal_brut>0 

/****phase 1-3-2: calage des cotisations des non salaris sur comptabilit nationale*/
egen masse_cs_nonsal_sim=total(cs_nonsal_sim*pondv/1000000000)
gen assiette_nonsal_cs_irpp=$masse_cs_nonsal_cn/masse_cs_nonsal_sim
gen cs_nonsal=cs_nonsal_sim
replace cs_nonsal=assiette_nonsal_cs_irpp*cs_nonsal_sim if calage==$calagecn
replace cs_nonsal_contr=cs_nonsal_contr*assiette_nonsal_cs_irpp if calage==$calagecn
replace cs_nonsal_noncontr=cs_nonsal_noncontr*assiette_nonsal_cs_irpp if calage==$calagecn
egen masse_nonsal_brut=total(nonsal_brut*pondv/1000000000)
gen assiette_nonsal_irpp_csg=masse_nonsal_brut/$masse_nonsal_csg
gen nonsal_brut_csg=nonsal_brut 
replace nonsal_brut_csg=nonsal_brut/assiette_nonsal_irpp_csg if calage==$calagecn
gen csg_nonsal=($tx_csg_ded_nonsal+$tx_csg_nonded_nonsal)*nonsal_brut_csg
gen csg_ya=csg_sal+csg_nonsal
gen assiette_nonsal_csg_cn=$masse_nonsal_csg/$masse_nonsal_cn
gen nonsal_brut_cn=nonsal_brut_csg
replace nonsal_brut_cn=nonsal_brut_csg/assiette_nonsal_csg_cn if calage==$calagecn
gen ya_cn=sal_superbrut_cn+nonsal_brut_cn
gen cs=css+csp+cs_nonsal
gen cs_contr=css_contr+csp_contr+cs_nonsal_contr
gen cs_noncontr=css_noncontr+csp_noncontr+cs_nonsal_noncontr

/*sauvegarde du fichier simul*/
save Fichiers/indiv_cotsoc_$annee, replace

/*prparation d'un tableau de rsultat*/
egen masse_css_priv_sim=total(css_sim*pondv*(1-public)/1000000000)
egen masse_css_pub_sim=total(css_sim*pondv*public/1000000000)
gen assiette_csp_net_irpp=$masse_csp_priv_cn/(masse_csp_priv_sim-masse_csp_priv_exo_fillon_sim)
collapse masse* assiette* 
keep masse_css_priv_sim masse_css_pub_sim assiette_css_irpp assiette_sal_irpp_csg_priv assiette_sal_irpp_csg_pub assiette_csp_irpp assiette_csp_exo_fillon assiette_csp_net_irpp assiette_nonsal_cs_irpp assiette_nonsal_irpp_csg 
save Resultats/CotSoc/statdes_cotsoc_$annee, replace

/*suppression de tous les paramtres masses, assiettes et simulations*/
use Fichiers/indiv_cotsoc_$annee, clear
drop tx* smic* masse* assiette* sal_h* nonsal_h* css_sim csp_sim* cs_nonsal_sim
save Fichiers/indiv_cotsoc_$annee, replace

/************** phase 2: calcul de la CSG-CRDS pour les revenus de remplacement*/

/*********phase 2-1: calcul pour les retraites*/
use Fichiers/indiv_irpp_$annee, clear
keep id_indiv rfr_irpp nbp irpp_net
sort id_indiv
merge id_indiv using Fichiers/indiv_cotsoc_$annee
drop _merge
gen pension_brut=pension_irpp if pension_irpp==0 | rfr_irpp<=$seuil_exo_th+2*(nbp-1)*$seuil_exo_th_demipart
replace pension_brut=pension_irpp/(1-$tx_csg_ded_pens_red) if rfr_irpp>$seuil_exo_th+2*(nbp-1)*$seuil_exo_th_demipart & irpp_net==0
replace pension_brut=pension_irpp/(1-$tx_csg_ded_pens) if rfr_irpp>$seuil_exo_th+2*(nbp-1)*$seuil_exo_th_demipart & irpp_net>0
gen csg_pens=0 if pension_irpp==0 | rfr_irpp<=$seuil_exo_th+2*(nbp-1)*$seuil_exo_th_demipart
replace csg_pens=($tx_csg_ded_pens_red+$tx_csg_nonded_pens_red)*pension_brut if rfr_irpp>$seuil_exo_th+2*(nbp-1)*$seuil_exo_th_demipart & irpp_net==0
replace csg_pens=($tx_csg_ded_pens+$tx_csg_nonded_pens)*pension_brut if rfr_irpp>$seuil_exo_th+2*(nbp-1)*$seuil_exo_th_demipart & irpp_net>0

/*********phase 2-2: calcul pour les allocations chmage et les prretraites*/
gen chom_brut=chom_irpp if chom_irpp==0 | rfr_irpp<=$seuil_exo_th+2*(nbp-1)*$seuil_exo_th_demipart
replace chom_brut=chom_irpp/(1-$tx_csg_ded_chom_red) if rfr_irpp>$seuil_exo_th+2*(nbp-1)*$seuil_exo_th_demipart & irpp_net==0
replace chom_brut=chom_irpp/(1-$tx_csg_ded_chom) if rfr_irpp>$seuil_exo_th+2*(nbp-1)*$seuil_exo_th_demipart & irpp_net>0
gen csg_chom=0 if chom_irpp==0 | rfr_irpp<=$seuil_exo_th+2*(nbp-1)*$seuil_exo_th_demipart
replace csg_chom=($tx_csg_ded_chom_red+$tx_csg_nonded_chom_red)*chom_brut if rfr_irpp>$seuil_exo_th+2*(nbp-1)*$seuil_exo_th_demipart & irpp_net==0
replace csg_chom=($tx_csg_ded_chom+$tx_csg_nonded_chom)*chom_brut if rfr_irpp>$seuil_exo_th+2*(nbp-1)*$seuil_exo_th_demipart & irpp_net>0

/*********calage sur comptabilit nationale*/
gen yr_brut=pension_brut+chom_brut
egen masse_remp_sim=total(yr_brut*pondv/1000000000)
gen assiette_remp_irpp_csg=masse_remp_sim/$masse_remp_csg
gen pension_csg=pension_brut  
replace pension_csg=pension_brut/assiette_remp_irpp_csg if calage==$calagecn
gen chom_csg=chom_brut
replace chom_csg=chom_brut/assiette_remp_irpp_csg if calage==$calagecn
gen yr_csg=pension_csg+chom_csg
replace csg_pens=csg_pens/assiette_remp_irpp_csg if calage==$calagecn
replace csg_chom=csg_chom/assiette_remp_irpp_csg if calage==$calagecn
gen csg_yr=csg_pens+csg_chom
gen assiette_remp_csg_cn=$masse_remp_csg/$masse_remp_cn
gen pension_cn=pension_csg
replace pension_cn=pension_csg/assiette_remp_csg_cn if calage==$calagecn
gen chom_cn=chom_csg
replace chom_cn=chom_csg/assiette_remp_csg_cn if calage==$calagecn
gen yr_cn=pension_cn+chom_cn

/*sauvegarde du fichier simul*/
save Fichiers/indiv_cotsoc_$annee, replace

/*prparation d'un tableau de rsultat avec tous les paramtres masses, effectifs et assiettes*/
collapse masse* assiette* 
keep assiette_remp_irpp_csg 
save Resultats/CotSoc/statdes_cotsoc_remp_$annee, replace

/*suppression de tous les paramtres masses, assiettes et simulations*/
use Fichiers/indiv_cotsoc_$annee, clear
drop masse* assiette*
keep  id_indiv pondv sal_brut css_contr css_noncontr css sal_brut_csg sal_brut_cn csp_exo_fillon csp_contr csp_noncontr csp csp_fac ts sal_superbrut_cn csg_sal nonsal_brut cs_nonsal_contr cs_nonsal_noncontr cs_nonsal nonsal_brut_csg csg_nonsal csg_ya nonsal_brut_cn ya_cn cs cs_contr cs_noncontr pension_brut csg_yr csg_pens chom_brut csg_chom yr_brut pension_csg chom_csg yr_csg pension_cn chom_cn yr_cn
order  id_indiv pondv sal_brut css_contr css_noncontr css sal_brut_csg sal_brut_cn csp_exo_fillon csp_contr csp_noncontr csp csp_fac ts sal_superbrut_cn csg_sal nonsal_brut cs_nonsal_contr cs_nonsal_noncontr cs_nonsal nonsal_brut_csg csg_nonsal csg_ya nonsal_brut_cn ya_cn cs cs_contr cs_noncontr pension_brut csg_yr csg_pens chom_brut csg_chom yr_brut pension_csg chom_csg yr_csg pension_cn chom_cn yr_cn
sort id_indiv
compress
save Fichiers/indiv_cotsoc_$annee, replace









