*********** simulation du nouveau systme de transferts
*********** choix de l'anne de simulation dans do_appel_parametres
*********** Choix du rpertoire racine dans do_appel_parametres ( excuter en premier)

clear

set mem 500m 
set more off


/******** appel des paramtres*/
do Programmes/do_appel_parametres

/******** appel des variables*/
use Fichiers/indiv_rev_$annee, clear
keep id_indiv rfon_irpp
sort id_indiv
merge id_indiv using Fichiers/indiv_ded_$annee
keep id_indiv rfon_irpp pens_alim_rec pens_alim_ver 
sort id_indiv
merge id_indiv using Fichiers/indiv_transferts_$annee
keep id_indiv rfon_irpp pens_alim_rec pens_alim_ver ppe pf mv rsa al alz
sort id_indiv
merge id_indiv using Fichiers/indiv_irpp_$annee
keep id_indiv rfon_irpp pens_alim_rec pens_alim_ver ppe pf mv rsa al alz irpp qf
sort id_indiv
merge id_indiv using Fichiers/indiv_revcap_$annee
keep id_indiv rfon_irpp pens_alim_rec pens_alim_ver irpp ppe pf mv rsa al alz qf rfin_csg rfin_dist_cn rfon_cn rfon_reel_cn rfon_fictif_cn csg_yk
sort id_indiv


/****************phase 1: simulation d'un nouveau systme de rduction d'impt pour enfants*/
/*****solution privilgie: nouvelles af forfaitaires s'ajoutant aux af existantes*/
/***** ici on prend simplement qfn=qf*/
/***** systme de dduction forfaitaire du revenu: voir do_prix_enfant*/
gen qfn=qf


/**************phase 2: adaptation du systme de transferts aux nouveaux revenus*/
/*du fait de la suppression de la CSG, tous les bas revenus augmentent, cela fait*/
/*faire des conomies sur tous les transferts sociaux: adapter barmes etc.*/
/*ici on suppose que rien ne change*/
gen pfn=pf
gen mvn=mv
gen rsan=rsa
gen aln=al
gen alzn=alz
gen ytn=pfn+mvn+rsan+aln+qfn

 
/************************phase 3: simulation d'un rsa totalement individualis*/
/*
/******* calcul du revenu universel (zone 1)*/
gen rev_univ=$rev_univ_base+$rev_univ_log_z1
replace rev_univ=max(rev_univ-$tx_retrait_ya*ya-$tx_retrait_yr*yr-$tx_retrait_yk*yk1,0)
egen masse_ru=total(rev_univ*pondv/1000000000)
*/


/****************************phase 4: sauvegarde du fichier simul*/
keep id_indiv ytn qfn pfn mvn rsan aln alzn
sort id_indiv
save Fichiers/indiv_nouv_transferts_$annee, replace


























