*********** simulation du crdit d'impt forfaitaire par enfant
*********** choix de l'anne de simulation dans do_appel_parametres
*********** Choix du rpertoire racine dans do_appel_parametres ( excuter en premier)

clear

set mem 500m 
set more off

/******** choix du mode de calage*/
global calagecn=0

/******** appel des paramtres*/
do Programmes/do_appel_parametres

/******** mise  jour des fichiers sources*/
do Programmes/do_mise_a_jour

/******** simulation du systme fiscalo-social*/
* inutile si programme excut dans le cadre de do_prog_complet
* do Programmes/do_irpp
* do Programmes/do_cotsoc
* do Programmes/do_revcap
* do Programmes/do_transferts
* do Programmes/do_nouvel_ir

/************ PHASE 1: prparation du fichier de travail utilis par les tableaux */
use Fichiers/indiv_demo_$annee, clear
keep id_indiv pondv age tempspartiel nenf sexe mat cohab marie
sort id_indiv
merge id_indiv using Fichiers/indiv_cotsoc_$annee
keep id_indiv pondv age tempspartiel nenf sexe mat cohab marie 
sort id_indiv
merge id_indiv using Fichiers/indiv_revcap_$annee
keep id_indiv pondv age tempspartiel nenf sexe mat cohab marie
sort id_indiv
merge id_indiv using Fichiers/indiv_irpp_$annee
keep id_indiv pondv age tempspartiel nenf sexe mat cohab marie qf 
sort id_indiv
merge id_indiv using Fichiers/indiv_nouvel_ir_$annee
keep id_indiv pondv age tempspartiel nenf sexe mat cohab marie qf 
sort id_indiv
merge id_indiv using Fichiers/indiv_transferts_$annee
replace paje=paje-paje_clca
keep id_indiv pondv age tempspartiel nenf sexe mat cohab marie qf af cf ars asf paje paje_clca pf 
sort id_indiv
merge id_indiv using Fichiers/indiv_aut_impots_$annee
gen nenftot=nenf
replace nenftot=nenf/2 if marie==1 | cohab==1
keep id_indiv pondv age tempspartiel nenf nenftot sexe mat cohab marie qf af cf ars asf paje paje_clca pf y_prim

/************ PHASE 2: calage sur comptanat et population totale (sauf qf) */
egen masse_af_sim=total(af*pondv/1000000000)
replace af=af*$masse_af/masse_af_sim
egen masse_cf_sim=total(cf*pondv/1000000000)
replace cf=cf*$masse_cf/masse_cf_sim
egen masse_ars_sim=total(ars*pondv/1000000000)
replace ars=ars*$masse_ars/masse_ars_sim
egen masse_asf_sim=total(asf*pondv/1000000000)
replace asf=asf*$masse_asf/masse_asf_sim
egen masse_paje_sim=total(paje*pondv/1000000000)
replace paje=paje*$masse_paje/masse_paje_sim
egen masse_paje_clca_sim=total(paje_clca*pondv/1000000000)
replace paje_clca=paje_clca*$masse_paje_clca/masse_paje_clca_sim
egen masse_pf_sim=total(pf*pondv/1000000000)
replace pf=pf*$masse_pf/masse_pf_sim
egen masse_nenftot_sim=total(nenftot*pondv)
replace nenftot=nenftot*$masse_nenftot/masse_nenftot_sim

/************ PHASE 3: prparation du fichier de travail utilis par les tableaux */
gen prixenfant=qf+af+cf+ars+asf+paje
cap gen pondvr=round(pondv)
cumul y_prim [w=pondvr], gen(py)
gen fractile=0
replace fractile=10*int(100*py/10) if py<.95
replace fractile=95 if py>=.95 & py<.96
replace fractile=96 if py>=.96 & py<.97
replace fractile=97 if py>=.97 & py<.98
replace fractile=98 if py>=.98 & py<.99
replace fractile=99 if py>=.99
keep id_indiv pondv age tempspartiel nenftot sexe mat cohab marie qf af cf ars asf paje paje_clca pf y_prim prixenfant fractile
g nenf2=nenftot*pondv

/************ PHASE 4: prparation du tableau prix enfant*/
collapse (rawsum) pondv totenf=nenf2 (min) seuil=y_prim (mean) y_prim sexe nenftot qf af cf ars asf  paje_clca paje pf prixenfant [w=pondv] if nenftot>0, by(fractile)
save Resultats/Enfants/prixenfant_$annee, replace
collapse (rawsum) pondv totenf (min) seuil (mean) y_prim sexe nenftot qf af cf ars asf  paje_clca paje pf prixenfant [w=pondv] if nenftot>0
append using Resultats/Enfants/prixenfant_$annee
order fractile  pondv seuil y_prim sexe totenf nenftot qf af cf ars asf paje paje_clca pf prixenfant
replace pf=af+cf+ars+asf+paje

foreach var of varlist qf af cf ars asf paje paje_clca pf prixenfant {
  replace `var'=`var'/nenftot
}

drop sexe 
gen prixenfant_mois=prixenfant/12
gen pf_mois=pf/12
gen qf_mois=qf/12
gen prixenfant_plat_mois=prixenfant_mois[1]

save Resultats/Enfants/prixenfant_$annee, replace


